﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sandbox.Common;
using Sandbox.Common.Components;
using Sandbox.ModAPI;
using Sandbox.ModAPI.Interfaces;
using Scripts.KSWH;
using VRageMath;
using Ingame = Sandbox.ModAPI.Ingame;

namespace Scripts.KSWH
{
    class CommanderActions
    {
        private static int AirstrikeCost = 50;


        public void HandleRequest(string input)
        {
            switch (input)
            {
                case "strike":
                    Airstrike();
                    break;
                default:
                    MissionComponent.hud.AddMessage((int)Hud.MessagePriority.Other, Hud.MessageLead + "//Unkown request");
                    break;
            }
            
        }

        public void Airstrike()
        {
            var tmp = MyAPIGateway.Session.Player.Controller.ControlledEntity.Entity as IMyCubeBlock;
            if (tmp == null)
            {
                MyAPIGateway.Utilities.ShowNotification("The commander has to control a ship to paint its target", 4000,
                    MyFontEnum.Red);
                return;
            }
            IMyCubeGrid painter = tmp.CubeGrid;
            
            List<IMySlimBlock> block = new List<IMySlimBlock>();
            painter.GetBlocks(block,
                x => x.FatBlock != null && x.FatBlock.BlockDefinition.TypeIdString == "MyObjectBuilder_LaserAntenna");
            if (block.Count == 0)
            {
                MyAPIGateway.Utilities.ShowNotification("You need a laser antenna to paint your target", 4000, MyFontEnum.Red);
                return;
            }
            if (!MissionComponent.host.PlayerPay(AirstrikeCost))
            {
                MissionComponent.hud.AddMessage((int)Hud.MessagePriority.Other, Hud.MessageLead + "//Request denied, You need " + AirstrikeCost + "$");
                return;
            }

            var antenna = block.First().FatBlock as Ingame.IMyLaserAntenna;

            Vector3D point = antenna.TargetCoords;
            if (MissionComponent.writeDebug)
            {
                MissionComponent.Speak("targeter", "Point is " + point.X + " " + point.Y + " " + point.Z);
            }

            Spawner.Spawn(StaticInformation.AirstrikePrefab, new Vector3D(point.X, point.Y, point.Z + 1000));

            MissionComponent.hud.AddMessage((int) Hud.MessagePriority.Other, Hud.MessageLead + "//Airstrike inbound");

        }

    }
}
