﻿using System;
using System.Collections.Generic;
using System.Linq;
using Sandbox.Common.ObjectBuilders;
using Sandbox.Definitions;
using Sandbox.ModAPI;
using Sandbox.ModAPI.Interfaces;

namespace Scripts.KSWH
{
    public abstract class Controlable
    {
        public IMyCubeGrid Grid { protected set; get; }

        public abstract int GetBounty();

        public void SetGrid(IMyCubeGrid grid)
        {
            Grid = grid;
            SetOwsnershipToEnemy();
        }

        protected void SetOwsnershipToEnemy()
        {
            try
            {
                Grid.ChangeGridOwnership(MissionComponent.host.enemy, MyOwnershipShareModeEnum.Faction);
            }
            catch (Exception)
            {
                //todo: ugly hack, clean up
            }

        }

        public IMyControllableEntity GetCockpit()
        {
            var tmp = new List<IMySlimBlock>();
            Grid.GetBlocks(tmp,
                s => s.FatBlock != null
                     && (s.FatBlock.BlockDefinition.TypeIdString == "MyObjectBuilder_Cockpit"
                         || s.FatBlock.BlockDefinition.TypeIdString == "MyObjectBuilder_RemoteControl"
                         )
                );

            // Loop through and filter by non-passenger
            var lst = (from block in tmp
                       let definition = MyDefinitionManager.Static.GetCubeBlockDefinition(block.FatBlock.BlockDefinition)
                       where
                           definition is MyShipControllerDefinition &&
                           (definition as MyShipControllerDefinition).EnableShipControl
                       select block).ToList();
            if (lst.Count > 0)
            {
                return lst[0].FatBlock as IMyControllableEntity;
            }
            return null;
        }
    }
}
