﻿using System;
using Sandbox.ModAPI;
using VRageMath;

namespace Scripts.KSWH
{
    class CruiserStation : Station
    {
        private const int MinDistance = 10;
        private const int ProductionTime = 10;
        private const int Resourcebonus = 200;
        public const int Buildconsts = 500;

        public CruiserStation()
        {
            Random r = new Random();
            Type = StationType.Cruiser;
            ThreadWrapper.OrderSpawn(StaticInformation.CruiserShipyard[r.Next(StaticInformation.CruiserShipyard.Length - 1)], GenerateLocation(MinDistance), this);
            Income = Resourcebonus;
            SetOwsnershipToEnemy();
        }

        public CruiserStation(IMyCubeGrid grid)
        {
            Grid = grid;
            Type = StationType.Cruiser;
            Income = Resourcebonus;
            SetOwsnershipToEnemy();
        }

        public void StartProduction()
        {
            if (!IsProducing)
            {
                if (!MissionComponent.host.AiPay(Cruiser.Price))
                {
                    return;
                }
                Random r = new Random(DateTime.Now.Minute);
                string prefab =
                    StaticInformation.CruiserPrefabList[r.Next(StaticInformation.CruiserPrefabList.Length - 1)];
                base.StartProduction(ProductionTime, prefab);
                if (MissionComponent.writeDebug)
                {
                    MissionComponent.Speak("Cruiser station", "Now building cruiser");
                }
            }
        }

        public static void HookAi(IMyEntity ent, int id)
        {
            Cruiser c = new Cruiser(ent as IMyCubeGrid, StaticInformation.AggroRange, id);
            MissionComponent.AddAiShip(c, id);
        }

        public override int GetBounty()
        {
            return 25;
        }
    }
}
