﻿using System;
using Sandbox.ModAPI;
using VRageMath;

namespace Scripts.KSWH
{
    class DestroyerStation : Station
    {
        private const int MinDistance = 7;
        private const int ProductionTime = 5;
        private const int ResourceBonus = 120;
        public const int BuildCosts = 300;

        public DestroyerStation()
        {
            Random r = new Random();
            Type = StationType.Destroyer;
            ThreadWrapper.OrderSpawn(StaticInformation.DestroyerShipyard[r.Next(StaticInformation.DestroyerShipyard.Length - 1)],
                    GenerateLocation(MinDistance), this);
            Income = ResourceBonus;
            
        }

        public DestroyerStation(IMyCubeGrid grid)
        {
            Grid = grid;
            Type = StationType.Destroyer;
            Income = ResourceBonus;
            SetOwsnershipToEnemy();
        }

        public void StartProduction()
        {
            if (!IsProducing)
            {
                if (!MissionComponent.host.AiPay(Destroyer.Price))
                {
                    return;
                }
                Random r = new Random(DateTime.Now.Minute);
                string prefab = StaticInformation.Destroyers[r.Next(StaticInformation.Destroyers.Length - 1)];
                base.StartProduction(ProductionTime, prefab);
                if (MissionComponent.writeDebug)
                {
                    MissionComponent.Speak("Destroyer station", "now producing destoryer");
                }

            }
        }

        public static void HookAi(IMyEntity ent, int id)
        {
            Destroyer d = new Destroyer(ent as IMyCubeGrid, StaticInformation.AggroRange,id);
            MissionComponent.AddAiShip(d, id);
        }

        public override int GetBounty()
        {
            return 20;
        }
    }
}
