﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Sandbox.ModAPI;
using Scripts.KSWH;
using VRage;

namespace Scripts.KSWH
{
    class Hud
    {
        private int currentHudLines = 0;
        private readonly int HudLenght = 150;
        private readonly FastResourceLock QueueLock = new FastResourceLock();
        private int updateCount = 0;
        private bool foundFirewall;
        private int messageCounter = 0;
        private readonly bool commander;
        private bool fakeInit;
        private string currentDisplay;
        private int rCounter = 0;
        private int tCounter = 0;
        private int lCounter;
        private readonly PriorityQueue<int, string> MessageQueue;
        public static string MessageLead = "\n\n\n\n\n\n\n";

        public enum MessagePriority
        {
            Critical = 1,
            Capital = 2,
            Battleship = 3,
            Missile = 4,
            Cruiser = 5,
            Destroyer = 6,
            Frigate = 7,
            Other = 8

        }

        private readonly string[] ScanMessages =
        {
            "<>",
            "<->",
            "<-->",
            "<--->",
            "<---->",
            "<--*-->",
            "< NO FIREWALL DETECTED >",
            "",
            "< NO FIREWALL DETECTED >",
            "",
            "< //SCANNING >"
        };

        private static string logo = "\n\n\n" +
                                     "                    __\n" +
                                     "                  ,'  `.\n" +
                                     "                 (   ,. `.\n" +
                                     "               ,'.`. `.`. `.\n" +
                                     "             ,.`. `.`. `.`. `.\n" +
                                     "            '. `.`. `.`. `.`. `,\n" +
                                     "          ,`. `. `.`. `.`. `.`' ,`.\n" +
                                     "        ,' ,',. `. `.`. `.`,' ,' ,',.\n" +
                                     "      ,' ,',' ,`__`. `'   ) ,' ,',' ,`__\n" +
                                     "    ,' ,',' ,','  `.`.__.',' ,',' ,','  `.\n" +
                                     "  ,' ,',' ,',' ,.   )   ,' ,',' ,',' ,.   )\n" +
                                     " (   `' ,',' ,',' ,'__ (   `' ,',' ,',' ,'\n" +
                                     "  `.__,',' ,',' ,','  `.`.__,',' ,',' ,'\n" +
                                     "      .' ,',' ,' (   ,. `.  .' ,',' ,'\n" +
                                     "       `',' ,','. `. `.`. `. `',' ,'\n" +
                                     "         `.',.`. `. `. `.`. `. `.'\n" +
                                     "           '. `.`. `. `. `.`. `,\n" +
                                     "             `. `.`. `. `. `.`'\n" +
                                     "               `. `.`. `. `,'\n" +
                                     "                 `. `'   )\n" +
                                     "                   `.__,'\n";

        private string[] bootupText =
        {
            "\nboot:",
            "\nLoading /casper/vmlinuz.................................                                                     ", //extra spaces on first line to align it properly on hud
            "\nLoading /casper/initrd.gz...............................",
            "\nLoading, please wait...",
            "\t\t[OK]",
            "\n* Setting preliminary keymap...",
            "\t\t[OK]",
            "\n* Preparing restricted drivers...",
            "\t\t[OK]",
            "\n* Starting kernel event manager...",
            "\t\t[OK]",
            "\n* Loading hardware drivers...",
            "\n[19.635933] piix4_smbus 0000:00:07.0: SMBus base address uninitialized - upgrade BIOS or use force_addr=0xaddr",
            "\n",
            "\n* Loading kernel modules...",
            "\t\t[OK]",
            "\n* Loading manual drivers...",
            "\t\t[OK]",
            "\n* Setting kernel variables (/etc/sysct1.conf)...",
            "\n* Setting kernel variables (/etc/sysct1.d/10-console-message.conf)...",
            "\n* Setting kernel variables (/etc/sysct1.d/10-network-security.conf)...",
            "\n* Mounting local filesystems...",
            "\t\t[OK]",
            "\n* Activating swapfile swap...",
            "\t\t[OK]",
            "\n* Starting firewall: ufw ...",
            "\t\t[WARN]",
            "\n* Configuring network interfaces...",
            "\t\t[OK]",
            "\n* Setting up console font and keymap...",
            "\t\t[OK]",
            "\n* Starting system log deamon...",
            "\t\t[OK]"
        };


        private string[] logoLines = logo.Split('\n');
        private int pickupPoint;

        public Hud()
        {
            commander = MyAPIGateway.Multiplayer.IsServer;
            MessageQueue = new PriorityQueue<int, string>();
            StringBuilder sb = new StringBuilder();
            pickupPoint = 501 + logoLines.Length;
            for (int i = 0; i < HudLenght; i++)
            {
                sb.Append(" ");
            }
            MyAPIGateway.Utilities.GetObjectiveLine().Title = "_";
            MyAPIGateway.Utilities.GetObjectiveLine().Objectives.Clear();
            MyAPIGateway.Utilities.GetObjectiveLine().Objectives.Add("");
            MyAPIGateway.Utilities.GetObjectiveLine().Show();
        }

        private void InitializeScreen()
        {
            if (lCounter == 6)
            {
                lCounter = 0;
            }
            else
            {
                lCounter++;
                return;
            }
            StringBuilder sbt = new StringBuilder();
            sbt.Append("Loading");
            for (int i = 0; i < tCounter; i++)
            {
                sbt.Append(".");
            }
            updateCount++;
            tCounter++;
            if (tCounter == 3)
            {
                tCounter = 0;
            }
            MyAPIGateway.Utilities.GetObjectiveLine().Title = sbt.ToString();
            if (MissionComponent.writeDebug)
            {
                MissionComponent.Speak("hud", "init is now state " + updateCount);
            }
            if (updateCount == 100)
            {
                updateCount = 480; //make it go a bit faster
            }
            if (updateCount > 500 && updateCount < 501 + logoLines.Length)
            {
                StringBuilder sb = new StringBuilder();
                for (int i = 0; i < updateCount - 500; i++)
                {
                    sb.Append(logoLines[i]);
                    sb.Append('\n');
                }
                currentDisplay = sb.ToString();
                MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = currentDisplay;
                return;
            }

            if (updateCount == pickupPoint + 50)
            {
                currentDisplay += "\n\nSTARTING...";
                MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = currentDisplay;
                return;
            }

            if (updateCount == pickupPoint + 100)
            {
                currentDisplay = "";
                MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = currentDisplay;
                return;
            }

            if (updateCount > pickupPoint + 110 && rCounter != bootupText.Length)
            {
                rCounter++;
                StringBuilder sb = new StringBuilder();
                for (int i = 0; i < rCounter; i++)
                {
                    sb.Append(bootupText[i]);
                }
                currentDisplay = sb.ToString();
                MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = currentDisplay;
                return;
            }
            if (updateCount == pickupPoint + 110 + bootupText.Length + 2)
            {
                pickupPoint = updateCount;
                return;
            }

            if (updateCount == pickupPoint + 10 && rCounter >= bootupText.Length)
            {
                currentDisplay = "";
                MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = currentDisplay;
                MyAPIGateway.Utilities.GetObjectiveLine().Title = commander
                    ? "**S.15 Command HUD**"
                    : "<<S.15 Emplyee HUD>>";
                rCounter = 0;
                updateCount = 0;
                tCounter = 0;
                lCounter = 0;
                fakeInit = true;
            }
        }

        public void UpdateFirewallHealth()
        {
            if (!fakeInit)
            {
                InitializeScreen();
                return;
            }
            updateCount++;
            if (updateCount == 50)
            {
                updateCount = 0;
                if (!foundFirewall)
                {
                    var res = MissionComponent.FindFirewall(false);
                    if (res != null)
                    {
                        foundFirewall = true;
                        MissionComponent.firewall = res;
                    }
                    else
                    {
                        MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = ScanMessages[messageCounter];
                        messageCounter++;
                        if (messageCounter > ScanMessages.Length - 1)
                        {
                            messageCounter = 0;
                        }
                        return;
                    }
                }
                try
                {
                    IMySlimBlock res;
                    res = commander ? MissionComponent.firewall : MissionComponent.FindFirewall();
                    if (res == null)
                    {
                        MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = "<<//FIREWALLE_CONNECTION::null>>";
                        foundFirewall = false;
                        return;
                    }
                    MissionComponent.firewall = res;
                    MissionComponent.CheckFirewall();
                }
                catch (Exception)
                {
                    MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = "<<//FIREWALLE_CONNECTION::timeout>>";
                    foundFirewall = false;
                }
                if (MyAPIGateway.Multiplayer.IsServer)
                {
                    DisplayMessage(); //results in nullpoiter for nonehost players (they don't have acces to the radar)
                }
                
            }
        }

        /// <summary>
        /// Add a message to the message list, the lower the priority the sooner it will be displayed (1 is lowest)
        /// note: this function is threadsave
        /// </summary>
        /// <param name="priority">Priority of the message</param>
        /// <param name="message">Content of the message (class will not manage alignment)</param>
        public void AddMessage(int priority, string message)
        {
            QueueLock.AcquireExclusive();
            MessageQueue.Enqueue(priority, message);
            QueueLock.ReleaseExclusive();
        }

        private void DisplayMessage()
        {
            QueueLock.AcquireExclusive();
            if (lCounter >= 20)
            {
                lCounter = 0;
                currentDisplay = "";
            }
            else if (!currentDisplay.Equals(""))
            {
                lCounter++;
                QueueLock.ReleaseExclusive();

                MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] += MissionComponent.rHandler.hasRadar ? currentDisplay : "";
                return;
            }
            if (!MessageQueue.IsEmpty)
            {
                currentDisplay = MessageQueue.DequeueValue();
            }
            MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] += MissionComponent.rHandler.hasRadar ? currentDisplay : "";
            QueueLock.ReleaseExclusive();
        }
    }
}
