﻿using System;
using Sandbox.ModAPI;
using VRageMath;

namespace Scripts.KSWH
{
    class LargeFactoryStation : Station
    {
         private const int MinDistance = 20;
        private const int ProductionTime = 1;
        private int ResourceBonus = 60;
        public const int BuildCosts = 850;

        public LargeFactoryStation()
        {
            Random r = new Random();
            Type = StationType.LargeLogistics;
            ThreadWrapper.OrderSpawn(StaticInformation.LargeLogisticStations[r.Next(StaticInformation.LargeLogisticStations.Length - 1)],
                    GenerateLocation(MinDistance), this);
            Income = ResourceBonus;
            SetOwsnershipToEnemy();
        }

        public LargeFactoryStation(IMyCubeGrid grid)
        {
            Grid = grid;
            Type = StationType.LargeLogistics;
            Income = ResourceBonus;
            SetOwsnershipToEnemy();
        }

        protected override void ManageResources()
        {
            base.ManageResources();
            if (ResourceBonus < 1000)
            {
                ResourceBonus += 2;
                Income = ResourceBonus;
            }
        }

        public void StartProduction()
        {
            //has no production
            MissionComponent.Speak("System", "Ai ordered a logistics station to produce something...");
        }

        public override int GetBounty()
        {
            return 20;
        }
    }
}
