﻿using Sandbox.ModAPI;
using Sandbox.ModAPI.Interfaces;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Remoting.Services;
using System.Text;
using Sandbox.Common;
using Sandbox.ModAPI.Ingame;
using VRage;
using VRageMath;
using VRageRender;
using IMyCubeGrid = Sandbox.ModAPI.IMyCubeGrid;
using IMySlimBlock = Sandbox.ModAPI.IMySlimBlock;

namespace Scripts.KSWH
{
    /// <summary>
    /// Simple class that handles the 'pings' comming form the game client.
    /// note: this class is not 'client side save' so you will have ot check if this code is running host or client side.
    /// After filtering this however your save for the rest of the program
    /// 
    /// note 2: please take in mind that the interface is running on .net 4 with x86 cpu architecture (<<that is probaply spelled wrong). So your local property settings should be the same!
    /// </summary>
    [MySessionComponentDescriptor(MyUpdateOrder.BeforeSimulation)]
    internal class MissionComponent : MySessionComponentBase
    {
        //private bool mInit = false;
        private bool mLoaded = false;
        private bool isLoading = false;
        private bool DisableScript = false;
        public static HostData host { private set; get; }
        private static DataHolder worldCache;
        public static bool writeDebug { private set; get; }
        public static IMySlimBlock firewall;
        public static bool hasFirewall = true;
        public static StationManager StationHandler;
        public int Updater = 0;
        public bool shownWelcomeMessage = false;
        //public static SimulationManager sManager = new SimulationManager();
        public bool SimulationThreadRunning = false;
        private bool KeepSimulationRunning;
        public static bool AiLivePing = false;
        private FastResourceLock locker = new FastResourceLock();
        public static int AiSpeedModifier { private set; get; }
        private static FastResourceLock SpeakLock = new FastResourceLock();
        private static FastResourceLock SimLock = new FastResourceLock();
        private static bool mEnableCheats;
        private static float mFirewallHp;
        private static float mMaxFirewallHp;
        private ClientFunctions mClient;
        public static bool AlarmDebug { private set; get; }
        public static Hud hud { private set; get; }
        public static IMySlimBlock Radar { private set; get; }
        private static int radarCheckCount;
        private static readonly Logger Logger = new Logger(null, "Core");
        public static AutopilotHandler AutoHandler { private set; get; }
        public static RadarHandler rHandler { private set; get; }
        private static int misCounter = 0;
        private static CommanderActions caHander;

        [System.Diagnostics.Conditional("DEBUG")]
        private static void Log(string toLog, string method = null, Logger.severity level = Logger.severity.DEBUG)
        {
            Logger.log(level, method, toLog);
        }

        public List<Ai> m_deleteEnemyCache = new List<Ai>();

        private int updateCounter = 0;


        public static Alarm AlarmHandler;
        public static EcmActions EcmHandler;


        private class Trigger
        {
            public Func<int, bool> UpdateMethod;
        }

        /*internal struct SimulationManager
        {
            public bool ShipSimulationRunning { get; set; }
            public bool StationSimulationRunning { get; set; }
        }*/

        private class DataHolder
        {
            private Dictionary<int,Ai> EnemyShips = new Dictionary<int, Ai>();
            public List<IMyCubeGrid> ControlledGrids = new List<IMyCubeGrid>();
            private FastResourceLock shipLock = new FastResourceLock();
            private Queue<Ai> handles = new Queue<Ai>();
            private static int maxPerCycle = 2;

            public void RemoveEnemyShip(int id)
            {
               shipLock.AcquireExclusive();
                if (EnemyShips.ContainsKey(id))
                {
                    var item = EnemyShips[id];
                    int bounty = item.GetBounty();
                    if (bounty > 0)
                    {
                        host.PlayerGain(bounty);
                    }
                    item.Dispose();
                    EnemyShips.Remove(id); 
                }
                shipLock.ReleaseExclusive();
            }

            public void AddEnemyShip(int id, Ai ship)
            {

                shipLock.AcquireExclusive();
                EnemyShips.Add(id, ship);
                handles.Enqueue(ship);
                shipLock.ReleaseExclusive();
            }

            public List<Ai> GetAiShips()
            {
                shipLock.AcquireExclusive();
                List<Ai> output = new List<Ai>();
                try
                {
                    if (handles.Count == 0)
                    {
                        return output;
                    }
                    int cycles = handles.Count;
                    if (cycles > maxPerCycle)
                    {
                        cycles = maxPerCycle;
                    }
                    //Speak("queer", "cycle counter is " + cycles);
                    for (int i = 0; i < cycles; i++)
                    {
                        var tmp = handles.Dequeue();
                        if (EnemyShips.ContainsKey(tmp.id))
                        {
                            output.Add(tmp);
                        }
                    }
                }
                catch (Exception e)
                {
                    Speak("Queue hander", "Error while getting ships: " + e);
                    Speak("Error details", "quefail, quelength: " + handles.Count + " mcycles: " + maxPerCycle);
                }
                finally
                {
                    shipLock.ReleaseExclusive();
                }
               
                
                return output;
            }

            public List<Ai> GetAllAiShips()
            {
                shipLock.AcquireExclusive();
                var output = EnemyShips.Values.ToList();
                shipLock.ReleaseExclusive();
                return output;
            } 

            public void ReQueue(Ai ship)
            {
                shipLock.AcquireExclusive();
                handles.Enqueue(ship);
                shipLock.ReleaseExclusive();
            }

            public int GetEnemyShipCount()
            {
                shipLock.AcquireExclusive();
                int ret = EnemyShips.Count;
                shipLock.ReleaseExclusive();
                return ret;
            }
        }

        /// <summary>
        /// Function that actually makes things happen, This code is executed before every simulation ping of the game engine
        /// </summary>
        public override void UpdateBeforeSimulation()
        {
            /*if (!mInit)
            {
                return;
            }*/

            if (DisableScript)
            {
                return;
            }

            if (MyAPIGateway.Session == null)
            {
                //god knows how this happends, I most certainly don't
                return;
            }

            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                //*****all code for client should be loaded and made ready in this if block *****

                if (!mLoaded)
                {
                    hud = new Hud(); //init hud for client
                    mClient = new ClientFunctions();
                    mLoaded = true;
                }
                hud.UpdateFirewallHealth();
                return;
            }

            if (!shownWelcomeMessage)
            {
                //show message
                StringBuilder ab = new StringBuilder();
                ab.Append("*** ");
                ab.Append(StaticInformation.Version);
                ab.Append(" ***\n\n");
                ab.Append("Update bullitens:\n");
                foreach (string message in StaticInformation.Messages)
                {
                    ab.Append(message);
                    ab.Append("\n");
                }
                if (StaticInformation.SubVersion != null)
                {
                    MyAPIGateway.Utilities.ShowMissionScreen("Sector 15 news", "Version: ", StaticInformation.Version + "\n" + StaticInformation.SubVersion, ab.ToString());
                }
                else
                {
                    MyAPIGateway.Utilities.ShowMissionScreen("Sector 15 news", "Version: ", StaticInformation.Version, ab.ToString());
                }

            
                shownWelcomeMessage = true;
            }

            if (!mLoaded)
            {
                //this load block is host (of sp) load only!
                MyAPIGateway.Utilities.MessageEntered += HandleCommand;
                
                hud = new Hud(); //init hud for host
                AiSpeedModifier = 0;
                var hostEntity = MyAPIGateway.Session.Player;
                host = new HostData(hostEntity.PlayerID);
                AutoHandler = new AutopilotHandler();
                AlarmHandler = new Alarm();
                rHandler = new RadarHandler();
                caHander = new CommanderActions();
                

                //try loading alreacy created npc hostiles
                //check if hostile faction exists
                if (!MyAPIGateway.Session.Factions.FactionTagExists(StaticInformation.HostileTag))
                {
                    MyAPIGateway.Session.Factions.CreateFaction(hostEntity.PlayerID, StaticInformation.HostileTag,
                        StaticInformation.HostileName, "We've Got the Future Under Control", "no really we do!");
                    //Notification("A unkown group calling themselfs " + StaticInformation.HostileName + " has been located in the sector", 50000, MyFontEnum.Blue);
                }

                //check if friendly faction exists
                if (!MyAPIGateway.Session.Factions.FactionTagExists(StaticInformation.FactionTag))
                {
                    //faction hook not yet created, for the sake of savety we better do so
                    MyAPIGateway.Session.Factions.CreateFaction(hostEntity.PlayerID, StaticInformation.FactionTag,
                        StaticInformation.FactionName, "Enter your faction desc here",
                        "Enter private message here, do NOT change the tag or name");
                    //Notification("Congratulations! you founded " + StaticInformation.FactionName, 50000, MyFontEnum.White);
                    host.SetFactionTag(StaticInformation.FactionTag);
                }
                else
                {
                    host.SetFactionTag(StaticInformation.FactionTag);
                }
                
                mLoaded = true;
                

                if (host.isSave && host.saveRun)
                {
                    host.run = host.saveRun;
                    Notification("Load game succesfull!", 25000, MyFontEnum.Green);
                    AlarmHandler.ScanForAlarms();
                    StartGame();
                }
                else
                {
                    Notification("The incursion is waiting for you, type /start to begin", 25000, MyFontEnum.Red);
                }
            }
            else if (host.run)
            {
                if (!GetSimulationState())
                {
                    ThreadWrapper.HandleOrders();
                    if (SimLock.TryAcquireExclusive())
                    {
                        
                        AutoHandler.DoUpdate();
                        MyAPIGateway.Parallel.StartBackground(SimulationCycle);
                        SimLock.AcquireExclusive();
                        //falltrough, only to keep the thread locked before returning it to the game engine to prevent multithreading issues
                        SimLock.ReleaseExclusive();
                        misCounter = 0;
                    }
                    else
                    {
                        misCounter++;
                        if (misCounter > 100)
                        {
                            Speak("WARNING", "Miscounter cirtical, restart suggested state:" + misCounter);
                        }
                    }
                }
            }
            
            if (radarCheckCount == 60)
            {
                if (!CheckRadar() && !MyAPIGateway.Multiplayer.IsServer)
                {
                    Radar = FindRadar();
                }
                else if (!CheckRadar())
                {
                    rHandler.ReScanRadars();
                }
                radarCheckCount = 0;
            }
            else
            {
                radarCheckCount++;
            }
            hud.UpdateFirewallHealth(); //host hud update
        }


        private bool GetSimulationState(bool reset = false, bool run = true)
        {
            bool res;
            locker.AcquireExclusive();
            if (reset)
            {
                KeepSimulationRunning = run;
                res = run;
            }
            else
            {
                res = KeepSimulationRunning;
            }
            locker.ReleaseExclusive();
            return res;
        }

        /// <summary>
        /// Remove the ai hook from a ship
        /// </summary>
        /// <param name="id">id of the ship to remove</param>
        public static void RemoveShipFromAiHook(int id)
        {
            AlarmHandler.KillSignal();
            worldCache.RemoveEnemyShip(id);
        }


        private void StartGame()
        {
            isLoading = true;
            Speak("start", "running init");
            Init();
            Speak("start", "scanning for firewall");
            FindFirewall();
            if (!CheckFirewall(false))
            {
                return;
            }
            Speak("start", "scanning hostiles");
            isLoading = false;
            ScanAndUpdateHostiles();
            
            Speak("start", "starting simulation cycle");
            //MyAPIGateway.Parallel.StartBackground(SimulationCycle);
        }

        private void SimulationCycle()
        {
            GetSimulationState(true);
            try
            {

                AlarmHandler.Update();

                UpdateHostiles();
                updateCounter++;
                if (updateCounter > 100)
                {

                    hasFirewall = CheckFirewall();

                    StationHandler.Update();

                    if (!hasFirewall)
                    {
                        firewall = null;
                        ThreadWrapper.Armegeddon();
                    }
                    updateCounter = 0;
                }
            }
            catch (Exception e)
            {
                //fall trough to be sure that the ai won't get stuck
                Speak("System", "Preventing the system from freezing, reloading station AI");
                Speak("ex", e.ToString());
            }
            finally
            {
                GetSimulationState(true, false);
                SimLock.ReleaseExclusive();
            }
            
        }


        /// <summary>
        /// initializing systems
        /// </summary>
        private void Init()
        {
            writeDebug = false;
            isLoading = true;
            if (MyAPIGateway.Multiplayer.IsServer)
            {
                Speak("system", "loading...");
                //init server components
                StationHandler = new StationManager();
                worldCache = new DataHolder();
                EcmHandler = new EcmActions();
                LoadStations();

                
                Speak("system", "host loading complete");

            }
            else
            {
                Speak("client", "you are a client");
                //Notification("You are a client", 100000, MyFontEnum.Green);
                //init player components
            }
            AlarmHandler.ScanNow();
            isLoading = false;

            //mInit = true;
        }

        /// <summary>
        /// function that will handle textual imput by the user
        /// </summary>
        /// <param name="messageText">entered text</param>
        /// <param name="sendToOthers"></param>
        private void HandleCommand(string messageText, ref bool sendToOthers)
        {

            if (!MyAPIGateway.Multiplayer.IsServer)
            {
                return; //you have to be the host to do this
            }
            if (messageText.StartsWith(".request"))
            {
                caHander.HandleRequest(messageText.Substring(9));
                return;
            }

            switch (messageText)
            {
                case "/version":
                    StringBuilder ab = new StringBuilder();
                    ab.Append("*** ");
                    ab.Append(StaticInformation.Version);
                    ab.Append(" ***\n\n");
                    ab.Append("Update bullitens:\n");
                    foreach (string message in StaticInformation.Messages)
                    {
                        ab.Append(message);
                        ab.Append("\n");
                    }
                    MyAPIGateway.Utilities.ShowMissionScreen("Sector 15 news", "Version: ", StaticInformation.Version, ab.ToString());
                    Speak("system", StaticInformation.Version);
                    break;
                case "/start":

                    Speak("start", "starting...");
                    if (host.run)
                    {
                        Speak("System", "Mod already running");
                        return;
                    }
                    Speak("start", "Scanning for firewall");
                    firewall = FindFirewall();
                    if (!hasFirewall)
                    {
                        Notification("You need a !firewall to start the game", 50000, MyFontEnum.Red);
                        return;
                    }

                    //Notification("WARNING: " + StaticInformation.HostileName + " declares war to " + StaticInformation.FactionName, 50000, MyFontEnum.Red);
                    Speak("base", "We are now at war with " + StaticInformation.HostileName + "!");
                    AlarmHandler.ScanForAlarms();
                    //TryLoadHostiles();
                    Speak("start", "booting up host handler");
                    host.Start();
                    StartGame();
                    break;
                case "/stop":
                    host.Stop();
                    Speak("System", "Executing AI commander, standby...");
                    break;
                case "/scanalarms":
                    Speak("base", "Scanning for new alarm towers");
                    AlarmHandler.ScanNow();
                    break;
                case "/sig":
                    Speak("base", "triggering sig");
                    AlarmHandler.NewSig();
                    break;
                case "/alarm":
                    Speak("base", "trigger alarm");
                    AlarmHandler.Alert((int)Hud.MessagePriority.Other, Hud.MessageLead + "Handling test alarm signal");
                    break;
                case "/clear":
                    Speak("base", "Giving all clear signal");
                    AlarmHandler.Clear();
                    break;
                case "/ecm":
                    Speak("base", "trigger ecm warning");
                    AlarmHandler.EcmWarning();
                    break;
                case "/setFactions":
                    Speak("system", "This call is depricated since version 0.0.7 and is no longer supported");
                    break;
                case "/HQ":
                    Speak("Base", "Teleporting in HQ now");
                    Spawner.Spawn("#HQ", new Vector3D(0, 0, 0));
                    break;
                case "/testMessage":
                    Speak("System", "Testing hud");
                    hud.AddMessage((int)Hud.MessagePriority.Other, "Test message");
                    break;
                case "/testinvader":
                    Speak("System", "Depricated method, please use /debugspawn [SHIPNAME]");
                    break;
                case "/bal":
                    Speak("Base", "Triggering ballistic alarm");
                    AlarmHandler.MissileWarning();
                    break;
                case "/rad":
                    Speak("Base", "Triggering radiation alarm");
                    AlarmHandler.RadWarning();
                    break;
                case "/debug":
                    writeDebug = !writeDebug;
                    Speak("System", "Debug flag is now flipping to " + writeDebug);
                    break;
                case "/hasfirewall":
                    firewall = FindFirewall();
                    Speak("system", "firewall found: " + hasFirewall);
                    break;
                case "/debugMissile":
                    Spawner.Spawn("cluster", new Vector3D(0, 0, 0));
                    Speak("System", "Spawned missle on 0 0 0");
                    break;
                case "/debugSave":
                    host.ForceSave();
                    host.DisplaySettingsFile();
                    break;
                case "/KillMeNow":
                    Speak("System", "The AI is now cheating");
                    host.AiResources += 10000;
                    break;
                case "/forceReloadAi":
                    Speak("System", "Forcing ship AI to reload");
                    ScanAndUpdateHostiles();
                    break;
                case "/aiCount":
                    Speak("System", "Ai is handling " + worldCache.GetEnemyShipCount() + " hooks");
                    break;
                case "/aiLog":
                    AiLivePing = !AiLivePing;
                    Speak("System", "Ai pings are now: " + AiLivePing);
                    break;
                case "/increaseAiSpeed":
                    AiSpeedModifier++;
                    Speak("System", "ai now builds faster (x" + AiSpeedModifier +")");
                    break;
                case "/decreaseAiSpeed":
                    AiSpeedModifier--;
                    Speak("System", "Ai now builds slower (x" + AiSpeedModifier + ")");
                    break;
                case "/resetAiSpeed":
                    AiSpeedModifier = 0;
                    Speak("System", "Ai speed modifier back to 0");
                    break;
                case "/stationCount":
                    Speak("System", "Ai has " + StationHandler.Stations.Count + " stations");
                    break;
                case "/maxAi":
                    Speak("System", "Ai has " + host.AiHookSlots + " slots");
                    break;
                case "/locks":
                    MyApiWrapper.LogLocks = true;
                    Speak("System", "Lock logging: " + MyApiWrapper.LogLocks);
                    break;
                case "/resetAlarmSystem":
                    AlarmHandler = new Alarm();
                    if (host.run)
                    {
                        MyAPIGateway.Utilities.ShowMissionScreen("WARNING", "Alarm system reset: ", "SUCCES",
                            "The alarm system is not mend to be reset while the game is running.\n\nThere is a change the system will mallfunction/not work at all from now on untill you restart the game");
                    }
                    break;
                case "/getIncursionLevel":
                    Speak("Base", "The current incursion is in state " + StationHandler.IncursionState);
                    break;
                case "/enableCheats":
                    mEnableCheats = !mEnableCheats;
                    Speak("Cheats", mEnableCheats.ToString());
                    break;
                case "/Bom":
                    if (!mEnableCheats || firewall == null)
                    {
                        return; //cheating disabled
                    }
                    Speak("CHEATING", "player is throwing boms");
                    var p = MyAPIGateway.Session.Player;
                    EcmHandler.LaunchMetoer(firewall.CubeGrid.GetPosition(), p.GetPosition(), p.Controller.ControlledEntity.Entity.WorldMatrix, EcmActions.Size.Large );
                    break;
                case "/Scrap":
                    if (!mEnableCheats || firewall == null)
                    {
                        return;
                    }
                    Speak("CHEATING", "player is starting a scrap storm");
                    EcmHandler.ScrapStorm(EcmActions.Size.Large, firewall.CubeGrid.GetPosition());
                    ThreadWrapper.HandleOrders();
                    break;
                case "/money":
                    if (!mEnableCheats)
                    {
                        return;
                    }
                    Speak("CHEATING", "player is granting himself money");
                    host.PlayerGain(1000);
                    break;
                case "/strike":
                    if (!mEnableCheats)
                    {
                        return;
                    }
                    Speak("CHEATING", "player is cheating in a airstrike");
                    caHander.Airstrike();
                    break;
                case "/debugAlarm":
                    AlarmDebug = !AlarmDebug;
                    Speak("system", "Alarm debug is now: " + AlarmDebug);
                    break;
            }
            if (messageText.Contains("/debugspawn"))
            {
                string[] parts = messageText.Split(' ');
                if (parts.Length == 2)
                {
                    Speak("System", "Spawning prefab " + parts[1] + " on 0 0 0");
                    Spawner.UnsaveSpawn(parts[1], new Vector3D(0, 0, 0));
                }
                else if (parts.Length == 5)
                {
                    try
                    {
                        int x = Convert.ToInt32(parts[2]);
                        int y = Convert.ToInt32(parts[3]);
                        int z = Convert.ToInt32(parts[4]);
                        Speak("System", "spawning ship at " + x + " " + y + " " + z);
                        Spawner.UnsaveSpawn(parts[1], new Vector3D(x, y, z));
                    }
                    catch (Exception e)
                    {
                        Speak("System", "Incorrect input");
                        //Speak("error", e.ToString());
                    }
                }
            }
            else if (messageText.Contains("/maxAi"))
            {
                string[] parts = messageText.Split(' ');
                if (parts.Length == 2)
                {
                    try
                    {
                        host.AiHookSlots = Convert.ToInt32(parts[1]);
                        host.ForceSave();
                        Speak("System", "Ai slots set to " + host.AiHookSlots);
                    }
                    catch (Exception)
                    {
                        Speak("System", "Failed to set ai slots, did you really input a number?");
                    }
                }
            }
            else if (messageText.Contains("/aiSpeed"))
            {
                string[] parts = messageText.Split(' ');
                if (parts.Length == 2)
                {
                    try
                    {
                        AiSpeedModifier = Convert.ToInt32(parts[1]);
                        Speak("System", "Speed multiplayer is now " + AiSpeedModifier + "x");
                    }
                    catch (Exception)
                    {
                        Speak("System", "Speed parameter has to be a whole number");
                    }
                }
                else
                {
                    Speak("System", "Incorrect syntax. Expected: /aiSpeed [SPEED]");
                }
            }
        }



        /// <summary>
        /// broadcast a message to all users
        /// </summary>
        /// <param name="who">person who's speaking</param>
        /// <param name="Message">text of the message</param>
        public static void Speak(string who, string message)
        {
            SpeakLock.AcquireExclusive();
            try
            {
                MyAPIGateway.Utilities.SendMessage(message);
                MyAPIGateway.Utilities.ShowMessage(who, message);
            }
            catch (Exception)
            {
                //falltrough to prevent endless lock
            }
            finally
            {
                SpeakLock.ReleaseExclusive();
            }

        }

        /// <summary>
        /// Get a list with all players
        /// </summary>
        /// <returns>a list of all current players</returns>
        public static List<IMyPlayer> GetPlayers()
        {
            List<IMyPlayer> players = new List<IMyPlayer>();
            MyAPIGateway.Players.GetPlayers(players, x => x != null);
            return players;
        }



        /// <summary>
        /// show a notification on the players screen (is not synced trough mp)
        /// </summary>
        /// <param name="message">message text</param>
        /// <param name="time">how long the message is displayed in ms</param>
        /// <param name="color">color of the message</param>
        public static void Notification(string message, int time, MyFontEnum color)
        {
            MyAPIGateway.Utilities.ShowNotification(message, time, color);
        }

        /// <summary>
        /// Add a ai hook to a created ai ship
        /// </summary>
        /// <param name="ship">the ai instance</param>
        /// <param name="id">The id for the new ship to be added to the dictionary</param>
        public static void AddAiShip(Ai ship, int id)
        {
            worldCache.AddEnemyShip(id, ship);
        }


        /// <summary>
        /// Exit eveint, cleans up the log writer
        /// </summary>
        protected override void UnloadData()
        {
            //todo: stop game engine
            host.Stop();
            MyApiWrapper.GetAiLock("Game unloading"); //force wait till everything has shut down correctly
            MyApiWrapper.ReleaseAiLock();
            base.UnloadData(); //unload base
            KeepSimulationRunning = false;
            MyAPIGateway.Utilities.MessageEntered -= HandleCommand; //unload handlers

        }

        private void UpdateHostiles()
        {
            List<Ai> ships = worldCache.GetAiShips();
            foreach (var ai in ships)
            {
                ai.GrantExecutionTime();
            }

            host.ActiveHooks = ships.Count;
        }


        private void ScanAndUpdateHostiles()
        {
            //scan if there are new hostiles
            if (isLoading)
            {
                return;
            }

            //do an update for the hostiles
            HashSet<IMyCubeGrid> allControlledEntities = new HashSet<IMyCubeGrid>();
            HashSet<IMyEntity> tmpEntityList = new HashSet<IMyEntity>();
            //get all entities
            MyAPIGateway.Entities.GetEntities(tmpEntityList,
                x => x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.CruiserTag)
                     || x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.BattleshipTag)
                     || x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.MissileTag)
                     || x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.FrigateTag)
                     || x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.DestroyerTag));
            foreach (IMyEntity entity in tmpEntityList)
            {
                allControlledEntities.Add(entity as IMyCubeGrid);
            }
            tmpEntityList.Clear();
            MyAPIGateway.Entities.GetEntities(tmpEntityList,
                x =>
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.CruiserTag) &&
                    !worldCache.ControlledGrids.Contains((IMyCubeGrid) x));
            foreach (IMyEntity entity in tmpEntityList)
            {
                //new cruiser class hostile ship found
                //check if its controlable
                var ship = entity as IMyCubeGrid;
                List<IMySlimBlock> lst = new List<IMySlimBlock>();
                ship.GetBlocks(lst, (x) => x.FatBlock is IMyControllableEntity);
                if (lst.Count > 0)
                {
                    //this is indeed controllable. Add it to world data
                    worldCache.AddEnemyShip(host.CreateshipId(), new Cruiser(ship, StaticInformation.AggroRange,
                        lst[0].FatBlock as IMyControllableEntity));
                    worldCache.ControlledGrids.Add(ship);
                }
            }
            tmpEntityList.Clear();
            MyAPIGateway.Entities.GetEntities(tmpEntityList,
                x =>
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.MissileTag) &&
                    !worldCache.ControlledGrids.Contains((IMyCubeGrid) x));
            foreach (IMyEntity entity in tmpEntityList)
            {
                var ship = entity as IMyCubeGrid;
                List<IMySlimBlock> lst = new List<IMySlimBlock>();
                ship.GetBlocks(lst, x => x.FatBlock is IMyControllableEntity);
                if (lst.Count > 0)
                {
                    worldCache.AddEnemyShip(host.CreateshipId(), new Missile(ship, lst[0].FatBlock as IMyControllableEntity));
                    worldCache.ControlledGrids.Add(ship);
                }
            }
            tmpEntityList.Clear();

            //detect frigates
            MyAPIGateway.Entities.GetEntities(tmpEntityList,
                x =>
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.FrigateTag) &&
                    !worldCache.ControlledGrids.Contains((IMyCubeGrid) x));
            foreach (IMyEntity entity in tmpEntityList)
            {
                var ship = entity as IMyCubeGrid;
                List<IMySlimBlock> lst = new List<IMySlimBlock>();
                ship.GetBlocks(lst, x => x.FatBlock is IMyControllableEntity);
                if (lst.Count > 0)
                {
                    worldCache.AddEnemyShip(host.CreateshipId(), new Frigate(ship, StaticInformation.AggroRange,
                        lst[0].FatBlock as IMyControllableEntity));
                    worldCache.ControlledGrids.Add(ship);
                }
            }
            tmpEntityList.Clear();

            //detect destroyers
            MyAPIGateway.Entities.GetEntities(tmpEntityList,
                x =>
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.DestroyerTag) &&
                    !worldCache.ControlledGrids.Contains((IMyCubeGrid) x));
            foreach (IMyEntity entity in tmpEntityList)
            {
                var ship = entity as IMyCubeGrid;
                List<IMySlimBlock> lst = new List<IMySlimBlock>();
                ship.GetBlocks(lst, x => x.FatBlock is IMyControllableEntity);
                if (lst.Count > 0)
                {
                    worldCache.AddEnemyShip(host.CreateshipId(), new Destroyer(ship, StaticInformation.AggroRange,
                        lst[0].FatBlock as IMyControllableEntity));
                    worldCache.ControlledGrids.Add(ship);
                }
            }
            tmpEntityList.Clear();

            //detect battleships
            MyAPIGateway.Entities.GetEntities(tmpEntityList,
                x =>
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.BattleshipTag) &&
                    !worldCache.ControlledGrids.Contains((IMyCubeGrid) x));
            foreach (IMyEntity entity in tmpEntityList)
            {
                //new cruiser class hostile ship found
                //check if its controlable

                var ship = entity as IMyCubeGrid;

                List<IMySlimBlock> lst = new List<IMySlimBlock>();
                ship.GetBlocks(lst, (x) => x.FatBlock is IMyControllableEntity);
                if (lst.Count > 0)
                {
                    //this is indeed controllable. Add it to world data
                    worldCache.AddEnemyShip(host.CreateshipId(), new BattleShip(ship, StaticInformation.AggroRange,
                        lst[0].FatBlock as IMyControllableEntity));
                    worldCache.ControlledGrids.Add(ship);
                }
            }

            //detect trash in cache
            var cleanUp =
                worldCache.GetAllAiShips().Where(
                    enemyShip =>
                        enemyShip.Grid.IsTrash() || !enemyShip.IsControlable ||
                        !allControlledEntities.Contains(enemyShip.Grid)).ToList();

            //clean trash out of cashe
            foreach (var trash in cleanUp)
            {
                worldCache.RemoveEnemyShip(trash.id);
            }

            host.ActiveHooks = worldCache.GetEnemyShipCount();

            //update all remaining targets
            List<Ai> allShips = worldCache.GetAllAiShips();
            foreach (var hostile in allShips)
            {
                try
                {
                    hostile.Update();
                        //has to be try catched as it unfortunally can throw a nullpointer when a player destoys the control seat while it is replotting a course
                    //changes are very low but the result is a CTD so better be save then have pretty code
                }
                catch (Exception)
                {
                    if (writeDebug)
                    {
                        Speak("Ai", "Failed to control ship");
                    }
                }
            }
        }

        /// <summary>
        /// Find if there is a radar. 
        /// CLIENT ONLY!
        /// </summary>
        /// <returns>the radar block</returns>
        public static IMySlimBlock FindRadar()
        {
            HashSet<IMyEntity> entities = new HashSet<IMyEntity>();
            MyAPIGateway.Entities.GetEntities(entities);
            foreach (IMyEntity ent in entities)
            {
                List<IMySlimBlock> blocks = new List<IMySlimBlock>();
                var grid = ent as IMyCubeGrid;
                if (grid == null)
                {
                    continue;
                }
                grid.GetBlocks(blocks, x => x.FatBlock != null && x.FatBlock.BlockDefinition.SubtypeId.Equals("RadarLarge"));
                if (blocks.Count == 0)
                {
                    continue;
                }
                var sRadar = blocks.First();
                return sRadar;
            }
            return null;
        }

        public static IMySlimBlock FindFirewall(bool messagebox = true)
        {
            IMySlimBlock sFirewall = null;
            bool firewallSet = false;
            HashSet<IMyEntity> ents = new HashSet<IMyEntity>();
            MyAPIGateway.Entities.GetEntities(ents);
            foreach (IMyEntity ent in ents)
            {
                List<IMySlimBlock> blocks = new List<IMySlimBlock>();
                var grid = ent as IMyCubeGrid;
                if (grid == null)
                {
                    continue;
                }
                grid.GetBlocks(blocks, x => x.FatBlock != null && x.FatBlock.BlockDefinition.SubtypeId.Equals("FireWall"));
                if (blocks.Count == 0)
                {
                    continue;
                }
                if (blocks.Count > 1)
                {
                    //more then 1 firewalle, go gameover
                    if (messagebox)
                    {
                        MyAPIGateway.Utilities.ShowMissionScreen("WARNING", "Firewall status: ", "CONFLICT",
                           "The firewall is not functioning properly as there is more then 1 in the current world. Please remove all but one firewall or you will die instandly!");
                    }
                    return null;
                }
                
                
                if (firewallSet)
                {
                    if (messagebox)
                    {
                        MyAPIGateway.Utilities.ShowMissionScreen("WARNING", "Firewall status: ", "CONFLICT",
                        "The firewall is not functioning properly as there is more then 1 in the current world. Please remove all but one firewall or you will die instandly!");
                    }
                    return null;
                }
                sFirewall = blocks.First();
                mMaxFirewallHp = sFirewall.MaxIntegrity;
                firewallSet = CheckFirewall(false);
                
            }
            hasFirewall = (sFirewall != null);
            if (!hasFirewall)
            {
                if (messagebox)
                {
                    MyAPIGateway.Utilities.ShowMissionScreen("WARNING", "Firewall status: ", "MISSING",
                          "The system could not find your firewall. If you open the rift now you have no change fighting of the incursion!\nTo build a firewall you should build a firewall block\nthis block can be found in the G menu");
              
                }
            }
            return sFirewall;
        }

        public static bool CheckRadar()
        {
            if (Radar == null)
            {
                return false;
            }
            if (Radar.BuildIntegrity <= 0)
            {
                //todo: notify on hud that the radar is gone
                Radar = null;
                return false;
            }
            if (Radar.IsDestroyed)
            {
                //todo: notify radar is destroyed
                return false;
            }
            if (Radar.IsFullyDismounted)
            {
                //todo: notify the radar is afloat
                return false;
            }
            if (!Radar.FatBlock.IsWorking)
            {
                //todo: notify the radar is offline
                return false;
            }
            return true;
        }

        public static void ReQueueAiHook(Ai ship)
        {
            worldCache.ReQueue(ship);
        }

        /// <summary>
        /// Check if the firewall is still oke
        /// </summary>
        /// <returns>bool if the firewall is operational</returns>
        public static bool CheckFirewall(bool updateHud = true)
        {
            if (firewall != null)
            {
                StringBuilder output = new StringBuilder();
                output.Append("<<FIREWALL\\\\INTEGRITY::");
                
                float currentHp = firewall.BuildIntegrity;
                int hp = (int)((currentHp/mMaxFirewallHp)*100);
                output.Append(hp);
                output.Append("%-STATUS::");
                
                if (currentHp < mMaxFirewallHp)
                {
                    if (MyAPIGateway.Multiplayer.IsServer)
                    {
                        AlarmHandler.DamageAlarm();
                    }
                    output.Append("Damaged");
                }
                else
                {
                    output.Append("ok");
                }
                output.Append("\\\\RADAR::");
                if (MyAPIGateway.Multiplayer.IsServer)
                {
                    output.Append(rHandler.hasRadar ? "online" : "offline");
                }
                else
                {
                    output.Append(Radar == null ? "offline" : "online");  
                }
                if (MyAPIGateway.Multiplayer.IsServer)
                {
                    output.Append("\\\\RESOURCES::");
                    output.Append(host.playerResources);
                    output.Append("$");
                }
                output.Append(">>");
                if (currentHp < mFirewallHp)
                {
                    output.Clear();
                    output.Append("<<FIREWALL TAKING DAMAGE::");
                    output.Append(hp);
                    output.Append(">>");
                }
                mFirewallHp = currentHp;
                if (updateHud)
                {
                    MyAPIGateway.Utilities.GetObjectiveLine().Objectives[0] = output.ToString();
                }
                
            }
            if (firewall == null) return false;
            return !firewall.IsDestroyed && !firewall.IsFullyDismounted;
        }

        
        private void LoadStations()
        {
            HashSet<IMyEntity> ents = new HashSet<IMyEntity>();
            MyAPIGateway.Entities.GetEntities(ents,
                x =>
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.ProductionTag) ||
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.LogisticTag) ||
                    x is IMyCubeGrid && x.DisplayName.Contains(StaticInformation.MissilePlatformTag));
            List<Station> stations = new List<Station>();
            foreach (IMyEntity ent in ents)
            {
                if (ent.DisplayName.Contains(StaticInformation.ProductionTag))
                {
                    int tagCount = ent.DisplayName.Count(x => x.Equals(StaticInformation.ProductionTag.ToCharArray()[0]));
                    switch (tagCount)
                    {
                        case 1:
                            if (writeDebug)
                            {
                                Speak("System", "Adding " + ent.DisplayName + " to frigate stations");
                            }
                            stations.Add(new FrigateStation(ent as IMyCubeGrid));
                            break;
                        case 2:
                            if (writeDebug)
                            {
                                Speak("System", "Adding " + ent.DisplayName + " to destroyer stations");
                            }
                            stations.Add(new DestroyerStation(ent as IMyCubeGrid));
                            break;
                        case 3:
                            if (writeDebug)
                            {
                                Speak("System", "Adding " + ent.DisplayName + " to cruiser stations");
                            }
                            stations.Add(new CruiserStation(ent as IMyCubeGrid));
                            break;
                        case 4:
                            stations.Add(new BattleshipStation(ent as IMyCubeGrid));
                            break;
                        default:
                            Speak("System", "ERROR: Invalid station name: " + ent.DisplayName);
                            break;
                    }
                }
                else if (ent.DisplayName.Contains(StaticInformation.LogisticTag))
                {
                    int tagCount = ent.DisplayName.Count(x => x.Equals(StaticInformation.LogisticTag.ToCharArray()[0]));
                    switch (tagCount)
                    {
                        case 1:
                            stations.Add(new SmallFactoryStation(ent as IMyCubeGrid));
                            break;
                        case 2:
                            stations.Add(new LargeFactoryStation(ent as IMyCubeGrid));
                            break;
                        default:
                            Speak("System", "ERROR: Invalid station name: " + ent.DisplayName);
                            break;
                    }
                }
                else if (ent.DisplayName.Contains(StaticInformation.MissilePlatformTag))
                {
                    int tagCount =
                        ent.DisplayName.Count(x => x.Equals(StaticInformation.MissilePlatformTag.ToCharArray()[0]));
                    switch (tagCount)
                    {
                        case 1:
                            stations.Add(new SmallLaunchPlatform(ent as IMyCubeGrid));
                            break;
                        case 2:
                            stations.Add(new LargeLaunchPlatform(ent as IMyCubeGrid));
                            break;
                        default:
                            Speak("System", "ERROR: Invalid station name: " + ent.DisplayName);
                            break;
                    }
                }
                else if (ent.DisplayName.Contains(StaticInformation.EcmStationTag))
                {
                    stations.Add(new EcmStation(ent as IMyCubeGrid));
                }
            }

            StationHandler.SetStations(stations);
        }

    }
}