﻿using Sandbox.ModAPI;
using VRage;

namespace Scripts.KSWH
{
    /// <summary>
    /// Class that wraps nonetrheasave parts of the api for the ship ai to play with
    /// </summary>
    public static class MyApiWrapper
    {
        private static FastResourceLock aiLock = new FastResourceLock();
        public static bool LogLocks { get; set; }

        /// <summary>
        /// Get teh entities thread save
        /// </summary>
        /// <returns>Acces to the entieies</returns>
        public static void GetAiLock(string reason)
        {
            if (LogLocks)
            {
                MissionComponent.Speak("Locking: ", reason);
            }
            aiLock.AcquireExclusive();
        }

        public static bool TryGetAiLock(string reason)
        {
            if (LogLocks)
            {
                MissionComponent.Speak("Locking: ", "Trying to get lock. " + reason);
            }
            return aiLock.TryAcquireExclusive();
        }

        /// <summary>
        /// Release the thread lock on entities
        /// </summary>
        public static void ReleaseAiLock()
        {
            aiLock.ReleaseExclusive();
        }

    }
}
