﻿using System;
using System.Text;

namespace Scripts.KSWH
{
    /// <summary>
    /// a helper class that will support with logging and handing errors. not important for the player but handy for developers
    /// </summary>
    public class ErrorHelper
    {
        public MyLogger logger;
        private bool debugEnabled;

        /// <summary>
        /// type of log, basically means what leading char will be used for the log message
        /// > : info
        /// ! : warning
        /// # : error (crash report)
        /// </summary>
        public enum logType
        {
            Info,
            Warning,
            Error
        }

        /// <summary>
        /// default constructor
        /// </summary>
        /// <param name="debugEnabled">enable the log</param>
        public ErrorHelper(bool debugEnabled)
        {
            this.debugEnabled = debugEnabled;
            if (debugEnabled)
            {
                logger = new MyLogger("RTS_AI_LOG");
                logger.WriteLine("Log starting up at " + DateTime.Now + " mod is running initialisation...");
            }
        }

        public void WriteLog(logType type, string Message)
        {
            if (debugEnabled)
            {
                StringBuilder sbMessage = new StringBuilder();
                switch (type)
                {
                    case logType.Info:
                        sbMessage.Append("> ");
                        break;
                    case logType.Warning:
                        sbMessage.Append("! ");
                        break;
                    case logType.Error:
                        sbMessage.Append("# ");
                        break;
                }
                sbMessage.Append(Message);
                logger.WriteLine(sbMessage.ToString());
            }
        }

        public void dispose()
        {
            WriteLog(logType.Info, "Session ended at " + DateTime.Now);
            logger.Close();
        }



    }
}
